@echo off

rem
rem  PostBuild event for NCS block diagram editor library.
rem

call ..\scripts\tools.bat
if errorlevel 1 goto ErrorExit

if "%1" == "Release" goto Release

:Debug
set  TARGET=Debug
goto MainFunction

:Release
set  TARGET=Release

:MainFunction

set EXEFILE=%TARGET%\extncs.dll
set NCSDIR=..\%TARGET%\modules\ncs
set MDLDIR=..\%TARGET%\modules\ncs\model
set BMPDIR=..\%TARGET%\modules\ncs\bmp
set INIFILE=..\..\..\..\win32\extension\extncs\data\block.default
set MDLSRC=..\..\..\..\win32\extension\extncs\data\model
set BMPSRC=..\..\..\..\win32\extension\extncs\data\bmp

rem  create ncs directory
if not exist %NCSDIR% mkdir %NCSDIR%

rem  create ncs/model directory
if not exist %MDLDIR% mkdir %MDLDIR%

rem  create ncs/bmp directory
if not exist %BMPDIR% mkdir %BMPDIR%

echo "copy /y %EXEFILE% ..\%TARGET%"
copy /y %EXEFILE% ..\%TARGET%

echo "%SED% %INIFILE% -e s/^##WIN32//g > ..\%TARGET%\modules\ncs\block.ini"
%SED% %INIFILE% -e s/^##WIN32//g > ..\%TARGET%\modules\ncs\block.ini

rem
rem copy models
rem

for %%A in (%MDLSRC%) do copy /y %%A %MDLDIR%

rem
rem copy models
rem

for %%A in (%BMPSRC%) do copy /y %%A %BMPDIR%

exit 0

:ErrorExit
exit 1
