/* 
 * Copyright (c) 2003 RIKEN (The Institute of Physical and Chemical Research)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY RIKEN AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL RIKEN OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

/* $Id: ParamWnd.h,v 1.2 2004/05/19 04:11:21 yoshihiko Exp $ */

#if !defined(AFX_PARAMWND_H__722456D2_2D65_4865_9705_7A8CC0A6F182__INCLUDED_)
#define AFX_PARAMWND_H__722456D2_2D65_4865_9705_7A8CC0A6F182__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ColorEdit.h"

/////////////////////////////////////////////////////////////////////////////
// CParamWnd t[

class CParamWnd : public CFrameWnd
{
	DECLARE_DYNCREATE(CParamWnd)
public:
	CParamWnd();           // IɎgpveNg RXgN^B

// Agr[g
public:

// Iy[V
public:
	//method
	BOOL	ParamInitialize();
	int		SetComboParamInit(CColorComboBox* p, CString v);
	BOOL	CheckParamValid(PARAMINFO *pItem, char* str);
	BOOL Create(LPCSTR szTitle, LONG style = 0,
			const RECT& rect = rectDefault,
			CWnd* pWnd = NULL,
			CWidget* pWidget = NULL);
	//data
	CFont m_font;
	int m_nStatic;
	CColorStatic *m_static[MAX_PARAM];
	int m_nEdit;
	CColorEdit *m_edit[MAX_PARAM];
	int m_nCombo;
	CColorComboBox *m_combo[MAX_PARAM];
	CWnd* m_pCtrl;
	COLORREF m_backColor;
	COLORREF m_foreColor;
	CToolBar m_toolBar;
	CSize m_sizeToolBar;
	int m_nSpin;
	CColorSpinButton	*m_spin[MAX_PARAM];
	CWnd* m_pWnd;
	CRect m_winRect;
	CWidget* m_pWidget;

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂

	//{{AFX_VIRTUAL(CParamWnd)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Cve[V
protected:
	virtual ~CParamWnd();

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CParamWnd)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnParamQuit();
	afx_msg void OnUpdateParamQuit(CCmdUI* pCmdUI);
	afx_msg void OnParamApply();
	afx_msg void OnUpdateParamApply(CCmdUI* pCmdUI);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnDestroy();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnAppExit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_PARAMWND_H__722456D2_2D65_4865_9705_7A8CC0A6F182__INCLUDED_)
