/* 
 * Copyright (c) 2003 RIKEN (The Institute of Physical and Chemical Research)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY RIKEN AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL RIKEN OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

/* $Id: ScopeWnd.h,v 1.2 2004/05/19 04:11:21 yoshihiko Exp $ */

#if !defined(AFX_SCOPEWND_H__F224B043_69C3_4841_B3D5_AE7A54D11057__INCLUDED_)
#define AFX_SCOPEWND_H__F224B043_69C3_4841_B3D5_AE7A54D11057__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CScopeWnd t[

class CScopeWnd : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CScopeWnd)
public:
	CScopeWnd();           // IɎgpveNg RXgN^B
	BOOL Create(LPCSTR szTitle, LONG style,
			const RECT& rect,
			CWnd* pScopeFrame,
			CWnd* pScopeList,
			char* varname,
			int varindex);

// Agr[g
public:

// Iy[V
public:
	void ScopeUpdate(int cycle, int index, int size, float* data);
	void ScopeSet(int scope, double simtime, double simstep, int cycle, int size);
	CString m_strVarname;
	CWidget*	m_pWidget;
	CWnd* m_pScopeList;
	CView*	m_pScopeView;
	int	m_nVarIndex;		//mscopeArrayvar̔ԍ

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂

	//{{AFX_VIRTUAL(CScopeWnd)
	public:
	virtual CDocument* GetActiveDocument();
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Cve[V
protected:
	virtual ~CScopeWnd();
	//CSplitterWnd m_wndSplitter;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CScopeWnd)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnAppExit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_SCOPEWND_H__F224B043_69C3_4841_B3D5_AE7A54D11057__INCLUDED_)
