/* 
 * Copyright (c) 2003 RIKEN (The Institute of Physical and Chemical Research)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY RIKEN AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL RIKEN OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

/* $Id: coloredit.h,v 1.2 2004/05/19 04:11:21 yoshihiko Exp $ */

#if !defined(AFX_COLOREDIT_H__22F33E3B_A351_11D1_BE77_0000C0D11F00__INCLUDED_)
#define AFX_COLOREDIT_H__22F33E3B_A351_11D1_BE77_0000C0D11F00__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CColorEdit EBhE

class CColorEdit : public CEdit
{
// RXgNV
public:
	CColorEdit();

// Agr[g
public:
	//OiFCwiFύX郁\bh
	void CColorEdit::SetColors(COLORREF fore,COLORREF back);
	void CColorEdit::GetColors(COLORREF& fore,COLORREF& back);
	void CColorEdit::Print(const char *str);

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CColorEdit)
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CColorEdit();

	// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CColorEdit)
	afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	//oϐ
	COLORREF	m_fore,m_back;
	HBRUSH		m_hBrBack;
};

/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CColorStatic EBhE

class CColorStatic : public CStatic
{
// RXgNV
public:
	CColorStatic();

// Agr[g
public:
	//OiFCwiFύX郁\bh
	void CColorStatic::SetColors(COLORREF fore,COLORREF back);
	void CColorStatic::GetColors(COLORREF& fore,COLORREF& back);

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CColorStatic)
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CColorStatic();

	// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CColorStatic)
	afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	//oϐ
	COLORREF	m_fore,m_back;
	HBRUSH		m_hBrBack;
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CColorComboBox EBhE

class CColorComboBox : public CComboBox
{
// RXgNV
public:
	CColorComboBox();

// Agr[g
public:
	//OiFCwiFύX郁\bh
	void CColorComboBox::SetColors(COLORREF fore,COLORREF back);
	void CColorComboBox::GetColors(COLORREF& fore,COLORREF& back);

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CColorComboBox)
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CColorComboBox();

	// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CColorComboBox)
	afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	//oϐ
	COLORREF	m_fore,m_back;
	HBRUSH		m_hBrBack;
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CColorSpinButton EBhE

class CColorSpinButton : public CSpinButtonCtrl
{
// RXgNV
public:
	CColorSpinButton();

// Agr[g
public:
	//OiFCwiFύX郁\bh
	void CColorSpinButton::SetColors(COLORREF fore,COLORREF back);
	void CColorSpinButton::GetColors(COLORREF& fore,COLORREF& back);

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CColorSpinButton)
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CColorSpinButton();

	// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CColorSpinButton)
	afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
	afx_msg UINT OnNcHitTest(CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	//oϐ
	COLORREF	m_fore,m_back;
	HBRUSH		m_hBrBack;
};

/////////////////////////////////////////////////////////////////////////////
//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_COLOREDIT_H__22F33E3B_A351_11D1_BE77_0000C0D11F00__INCLUDED_)
