/* 
 * Copyright (c) 2003 RIKEN (The Institute of Physical and Chemical Research)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY RIKEN AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL RIKEN OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

/* $Id: slio.cpp,v 1.1.1.1 2004/03/31 08:15:06 orrisroot Exp $ */
//
//	SLIO module
//	slio.cpp
//

#include <windows.h>
#include <stdio.h>
#include "SL_macro.h"
#include "SL_cmd.h"
#define  __IMPORTSYMBOL__
#include "libsatellite.h"
#undef   __IMPORTSYMBOL__

#ifdef __cplusplus
extern "C" {
#endif

DLLEXPORT const char *SetupCommand(){
  static char *setup_command="setup"; 
  return setup_command;
}

DLLEXPORT const char *CleanCommand(){
  static char *clean_command="clean";
  return clean_command;
}

//this routine is executed when initialize
int DLLEXPORT setup()
{
#if 0
	HINSTANCE   hinstDll;
	char path[_MAX_PATH];
	char dll[_MAX_PATH];

	//system directory
	::GetSystemDirectory(path, _MAX_PATH);

	//whether Fbiad.dll is
	//Load the DLL.
	sprintf(dll,"%s\\fbiad.dll",path);
	hinstDll = ::LoadLibrary(dll);
	if(!hinstDll) {
		printf("Fbiad.dll not exist. (SLIO module)\n");
		return 1;
	}
	else {
		::FreeLibrary(hinstDll);
	}
	//whether Fbida.dll is
	//Load the DLL.
	sprintf(dll,"%s\\fbida.dll",path);
	hinstDll = ::LoadLibrary(dll);
	if(!hinstDll) {
		printf("Fbida.dll not exist. (SLIO module)\n");
		return 1;
	}
	else {
		::FreeLibrary(hinstDll);
	}
#endif
	return 0;
}

//this routine is executed when exit
int DLLEXPORT clean()
{
	return 0;
}

#ifdef __cplusplus
}
#endif
